export interface IOptions {
    ssm: any;
    strict?: boolean;
}
export declare function loadConfig<T>(configFilePath: string, options: IOptions): Promise<T>;
export declare function loadSsmParamsIntoConfig<T>(config: T, options: IOptions): Promise<T>;
export interface IParamMap {
    key: string;
    to: string;
}
export declare function loadMappedSsmParamsIntoConfig<T>(config: T, paramMap: IParamMap[], options: IOptions): Promise<T>;
export interface ISSMResponse {
    Parameters: Array<{
        Name: string;
        Type: 'String' | 'StringList' | 'SecureString';
        Value: string;
    }>;
    InvalidParameters: string[];
}
