"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:no-console
var ssm_mock_1 = require("../test/ssm_mock");
var model = require("./index");
var chai = require("chai");
var path = require("path");
var expect = chai.expect;
var configToTest = JSON.parse(JSON.stringify(require('../test/config_to_test.json')));
var configFilePath = path.resolve(__dirname, '../test/config_to_test.json');
describe('model', function () {
    var config;
    beforeEach(function () {
        config = JSON.parse(JSON.stringify(configToTest));
    });
    function testConfig(c) {
        expect(c).to.be.an('object');
        expect(c).to.have.property('b', '{bv');
        expect(c).to.have.property('c').which.is.an('object');
        // auto parse json
        expect(c.c).to.have.property('c1').which.is.an('object');
        expect(c.c.c1).to.have.property('c1v', 23);
        expect(c.c).to.have.property('c2').which.is.an('object');
        expect(c.c.c2).to.have.property('c21', 'c21v');
        expect(c.c.c2).to.have.property('c22', 2);
    }
    describe('model.loadConfig', function () {
        it('should work', function () { return __awaiter(_this, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.loadConfig(configFilePath, {
                            ssm: ssm_mock_1.default
                        })];
                    case 1:
                        c = _a.sent();
                        testConfig(c);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('model.loadSsmParamsIntoConfig', function () {
        it('should work', function () { return __awaiter(_this, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.loadSsmParamsIntoConfig(config, {
                            ssm: ssm_mock_1.default
                        })];
                    case 1:
                        c = _a.sent();
                        testConfig(c);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('model.loadMappedSsmParamsIntoConfig', function () {
        it('should work', function () { return __awaiter(_this, void 0, void 0, function () {
            var mapper, c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mapper = [{ key: '/path/b', to: 'b' },
                            { key: '/path/c21', to: 'c.c2.c21' }];
                        return [4 /*yield*/, model.loadMappedSsmParamsIntoConfig(config, mapper, {
                                ssm: ssm_mock_1.default
                            })];
                    case 1:
                        c = _a.sent();
                        expect(c).to.be.an('object');
                        expect(c).to.have.property('b', '{bv');
                        expect(c).to.have.property('c').which.is.an('object');
                        // this wasnt mapped
                        expect(c.c).to.have.property('c1', 'ssm:/path/c1');
                        expect(c.c).to.have.property('c2').which.is.an('object');
                        expect(c.c.c2).to.have.property('c21', 'c21v');
                        expect(c.c.c2).to.have.property('c22', 2);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
